Public Class Form1
    Private Declare Sub mouse_event Lib "user32" (ByVal dwFlags As Integer, ByVal dx As Integer, ByVal dy As Integer, ByVal cButtons As Integer, ByVal dwExtraInfo As Integer)
    Private Const MOUSEEVENTF_MOVE As Integer = &H1          ' mouse move
    Private Const MOUSEEVENTF_LEFTDOWN As Integer = &H2      ' left button down
    Private Const MOUSEEVENTF_LEFTUP As Integer = &H4        ' left button up
    Private Const MOUSEEVENTF_RIGHTDOWN As Integer = &H8     ' right button down
    Private Const MOUSEEVENTF_RIGHTUP As Integer = &H10      ' right button up
    Private Const MOUSEEVENTF_MIDDLEDOWN As Integer = &H20   ' middle button down
    Private Const MOUSEEVENTF_MIDDLEUP As Integer = &H40     ' middle button up
    Private Const MOUSEEVENTF_WHEEL As Integer = &H800       ' wheel button rolled
    Private Const MOUSEEVENTF_ABSOLUTE As Integer = &H8000   ' absolute move

    Private m_Target As New Point(200, 150)

    Private Sub btnMoveClick_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMoveClick.Click
        ' Convert the target to absolute screen coordinates.
        Dim pt As Point = Me.PointToScreen(m_Target)

        ' mouse_event moves in a coordinate system where
        ' (0, 0) is in the upper left corner and
        ' (65535,65535) is in the lower right corner.
        ' Convert the coordinates.
        Dim screen_bounds As Rectangle = Screen.GetBounds(pt)
        Dim x As Integer = CInt(pt.X * 65535 / screen_bounds.Width)
        Dim y As Integer = CInt(pt.Y * 65535 / screen_bounds.Height)

        ' Move the mouse.
        mouse_event( _
            MOUSEEVENTF_ABSOLUTE + _
            MOUSEEVENTF_MOVE, _
            x, y, 0, 0)

        ' Click there.
        mouse_event( _
            MOUSEEVENTF_ABSOLUTE Or _
            MOUSEEVENTF_MOVE Or _
            MOUSEEVENTF_LEFTDOWN Or _
            MOUSEEVENTF_LEFTUP, _
            x, y, 0, 0)
    End Sub

    ' Draw an X where the user clicked.
    Private Sub Form1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Click
        ' Get the mouse position.
        Dim pt As Point = MousePosition()

        ' Convert to screen coordinates.
        pt = Me.PointToClient(pt)

        Dim gr As Graphics = Me.CreateGraphics()
        gr.DrawLine(Pens.Blue, pt.X - 5, pt.Y - 5, pt.X + 5, pt.Y + 5)
        gr.DrawLine(Pens.Blue, pt.X + 5, pt.Y - 5, pt.X - 5, pt.Y + 5)
    End Sub

    ' Draw a target.
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        For i As Integer = 2 To 20 Step 5
            e.Graphics.DrawEllipse(Pens.Red, m_Target.X - i, m_Target.Y - i, 2 * i, 2 * i)
        Next
    End Sub
End Class
